<?php

if ( !defined( 'ABSPATH' ) ) {
    exit;
}
if ( !current_user_can( 'update_plugins' ) ) {
    wp_die( __( 'You are not allowed to update plugins on this blog.', 'seo-booster' ) );
}
global  $wpdb, $seobooster_fs ;
$foftable = $wpdb->prefix . "sb2_404";
$bltable = $wpdb->prefix . "sb2_bl";
?>
<div class="wrap">
	<?php 
global  $seobooster_fs ;
// todo
$kws_google = $wpdb->get_var( "SELECT count(*) as kws FROM {$wpdb->prefix}sb2_kw WHERE `kw` NOT LIKE '#' AND `engine` LIKE '%google%';" );
$kws_not_google = $wpdb->get_var( "SELECT count(*) as kws FROM {$wpdb->prefix}sb2_kw WHERE `kw` NOT LIKE '#' AND `engine` NOT LIKE '%google%' AND `engine` NOT LIKE 'Internal Search'" );
$kws_total = $kws_google + $kws_not_google;
$traffic_google = $wpdb->get_var( "SELECT sum(visits) FROM {$wpdb->prefix}sb2_kw WHERE `engine` LIKE '%google.%';" );
$traffic_not_google = $wpdb->get_var( "SELECT sum(visits) FROM {$wpdb->prefix}sb2_kw WHERE `engine` NOT LIKE '%google.%';" );
$traffic_total = $traffic_google + $traffic_not_google;
$lps_google = $wpdb->get_var( "SELECT count(DISTINCT(lp)) FROM {$wpdb->prefix}sb2_kw WHERE `engine` LIKE '%google.%';" );
$lps_not_google = $wpdb->get_var( "SELECT count(DISTINCT(lp)) FROM {$wpdb->prefix}sb2_kw WHERE `engine` NOT LIKE '%google.%';" );
$over90daysold = $wpdb->get_var( "SELECT COUNT(*) AS cnt FROM {$wpdb->prefix}sb2_kw pm WHERE lastvisit < DATE_SUB(NOW(), INTERVAL 90 DAY)" );
$known_keywords = $wpdb->get_var( "SELECT COUNT(*) FROM {$wpdb->prefix}sb2_kw WHERE `kw` <> '#' AND `engine` NOT LIKE 'Internal Search';" );
include_once SEOBOOSTER_PLUGINPATH . 'inc/adminheader.php';
// Contains general info
?>
	<h1><?php 
_e( 'Dashboard', 'seo-booster' );
?> - SEO Booster v.<?php 
echo  SEOBOOSTER_VERSION ;
?></h1>

	<p><a href="#" class="quickhelp" data-beacon-article="5936127b2c7d3a0747cdac49"><?php 
_e( 'Quick help', 'seo-booster' );
?></a></p>
	<?php 
// TESTING AND FIXING DATABASE TABLES

if ( isset( $_POST['page'] ) && 'sb2_dashboard' === $_POST['page'] ) {
    // todo - verify nonce
    $nonce = $_REQUEST['_wpnonce'];
    
    if ( !wp_verify_nonce( $nonce, 'fixdbtables' ) ) {
        die( 'Security check' );
    } else {
        $this->create_database_tables();
        ?>

			<div class="notice notice-success">
				<h3><?php 
        _e( 'Database tables updated', 'seo-booster' );
        ?></h3>

			</div>
			<?php 
    }

}

global  $wpdb ;
$dbliste = array(
    $wpdb->prefix . 'sb2_autolink',
    $wpdb->prefix . 'sb2_bl',
    $wpdb->prefix . 'sb2_kwdt',
    $wpdb->prefix . 'sb2_crawl',
    $wpdb->prefix . 'sb2_urls',
    $wpdb->prefix . 'sb2_urls_meta',
    $wpdb->prefix . 'sb2_404',
    $wpdb->prefix . 'sb2_log',
    $wpdb->prefix . 'sb2_kw'
);
$missing = '';
foreach ( $dbliste as $dbt ) {
    $query = $wpdb->prepare( 'SHOW TABLES LIKE %s', $dbt );
    
    if ( $wpdb->get_var( $query ) == $dbt ) {
    } else {
        $missing .= '<p>' . sprintf( __( 'Database table %1$s is missing.', 'seo-booster' ), '<code>' . $dbt . '</code>' ) . '</p>';
    }

}
$seobooster_db_version = get_option( 'SEOBOOSTER_INSTALLED_DB_VERSION', '1.0' );
// latest update
if ( version_compare( $seobooster_db_version, SEOBOOSTER_DB_VERSION ) < 0 ) {
    $missing .= '<p>' . sprintf( __( 'Database out of date %1$s vs. current %2$s', 'seo-booster' ), $seobooster_db_version, SEOBOOSTER_DB_VERSION ) . '</p>';
}

if ( $missing ) {
    ?>
			<div class="notice notice-error">
				<h3><?php 
    _e( 'Database tables needs updating', 'seo-booster' );
    ?></h3>
				<?php 
    echo  $missing ;
    ?>

				<form id="fixdatabase" method="post">
					<input type="hidden" name="page" value="<?php 
    echo  $_REQUEST['page'] ;
    ?>" />
					<input type="hidden" name="action" value="sbp_fixdatabasetables" />
					<input type="hidden" name="_wpnonce" value="<?php 
    echo  wp_create_nonce( 'fixdbtables' ) ;
    ?>" />
					<?php 
    submit_button(
        'Click here to fix',
        'primary',
        'updatedb',
        true
    );
    ?>
				</form>

			</div>
			<?php 
}

?>



		<div id="welcome-panel" class="welcome-panel clearfix clear">
			<div id="inner-welcome">
				<div class="welcome-panel-content">


					<div class="wp-columns">

						<div class="welcome-panel-column1">
							<img src='<?php 
echo  plugin_dir_url( __FILE__ ) ;
?>images/seoboosterlogo.png' height="35" width="150" class="seoboosterlogo" alt="SEO Booster">

							<?php 
include 'inc/search_engines.php';

if ( $sengine ) {
    $secount = count( $sengine );
    ?>
								<p class="lead"><?php 
    printf( esc_html__( 'Tracking visitors from %1$s keyword sources.', 'seo-booster' ), '<span>' . number_format_i18n( $secount ) . '</span>' );
    ?></p>
								<?php 
}

?>
							<p class="lead"><?php 
_e( 'Uncluttered view of what content brings traffic.', 'seo-booster' );
?></p>

							<?php 
$show_welcome_text = true;
$engines_arr = $wpdb->get_results( "SELECT engine, sum(visits) as visits from {$wpdb->prefix}sb2_kw WHERE `engine` NOT LIKE 'Internal Search' AND `engine` NOT LIKE '%google.%' GROUP BY engine ORDER BY visits DESC;" );
$totalengines = count( $engines_arr ) + 1;

if ( $known_keywords > 2 ) {
    $show_welcome_text = false;
    
    if ( $engines_arr ) {
        echo  '<h3>' . __( 'Quick Overview', 'seo-booster' ) . '</h3>' ;
        echo  '<p class="quickie">' . sprintf( __( "Since installation SEO BOOSTER has recorded <span>%s</span> keywords found from visitors and <span>%s</span> sources.", 'seo-booster' ), number_format_i18n( $known_keywords ), number_format_i18n( $totalengines ) ) . '</p>' ;
    }
    
    $latestlimit = 10;
    $latestkws = $wpdb->get_results( "SELECT kw, engine, firstvisit FROM {$wpdb->prefix}sb2_kw WHERE `engine` NOT LIKE 'Internal Search' AND `kw`<>'#' GROUP BY kw ORDER BY visits ASC LIMIT {$latestlimit};" );
    
    if ( $latestkws ) {
        echo  '<p>' . __( "Latest detected keywords:", 'seo-booster' ) . '</p>' ;
        echo  '<div class="kwcontainer">' ;
        foreach ( $latestkws as $lkw ) {
            $engine = $lkw->engine;
            $engine = str_replace( 'www.', '', $engine );
            $kw = str_replace( '  ', ' ', $lkw->kw );
            echo  '<div class="kws">' . trim( $kw ) . '</div>' ;
        }
        echo  '</div>' ;
        echo  "<div class='clearfix'></div>" ;
    }

} else {
}

$totalbls = $wpdb->get_var( "SELECT count(*) FROM {$bltable};" );

if ( $totalbls > 0 ) {
    $show_welcome_text = false;
    echo  '<p class="quickie">' . sprintf( __( "Found <span>%s</span>  external links from visitors.", 'seo-booster' ), number_format_i18n( $totalbls ), number_format_i18n( $totalengines ) ) . '</p>' ;
}

$totalfofs = $wpdb->get_var( "SELECT count(*) FROM {$foftable};" );

if ( $totalfofs > 0 ) {
    $show_welcome_text = false;
    echo  '<p class="quickie">' . sprintf( __( "Detected <span>%s</span> not found pages and links.", 'seo-booster' ), number_format_i18n( $totalfofs ) ) . '</p>' ;
}


if ( $show_welcome_text ) {
    ?>
								<h3><?php 
    _e( 'Seems a bit boring here?', 'seo-booster' );
    ?></h3>

								<p class="lead"><?php 
    _e( 'If you have just installed the plugin, that is to be expected.', 'seo-booster' );
    ?></p>

								<p><?php 
    _e( 'The plugin needs some time to listen to your traffic and figure out the details.', 'seo-booster' );
    ?></p>
								<?php 
}

?>
						</div><!-- .welcome-panel-column1 -->
						<div class="helpbox">
							<h3><span class="dashicons dashicons-welcome-learn-more"></span>  <?php 
_e( 'Need help?', 'seo-booster' );
?></h3>
							<ul>
								<li><?php 
printf( '<a href="%s" target="_blank">' . __( 'Documentation', 'seo-booster' ) . '</a>', 'https://cleverplugins.com/docs/' );
?></li>
								<li><?php 
printf( '<a href="%s" target="_blank">' . __( 'Get support', 'seo-booster' ) . '</a>', 'https://cleverplugins.com/support/' );
?></li>
							</ul>

							<h3><span class="dashicons dashicons-welcome-widgets-menus"></span> <?php 
_e( 'Plugin pages', 'seo-booster' );
?></h3>
							<ul>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_settings' ) ;
?>"><?php 
_e( 'The Settings', 'seo-booster' );
?></a></li>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_keywords' ) ;
?>"><?php 
_e( 'Keyword Details', 'seo-booster' );
?></a></li>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_backlinks' ) ;
?>"><?php 
_e( 'Backlink Details', 'seo-booster' );
?></a></li>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_crawled' ) ;
?>"><?php 
_e( 'Crawled Pages', 'seo-booster' );
?></a></li>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_404s' ) ;
?>"><?php 
_e( '404 Errors', 'seo-booster' );
?></a></li>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_forgotten' ) ;
?>"><?php 
_e( 'Forgotten Pages', 'seo-booster' );
?></a></li>
								<li><a href="<?php 
echo  admin_url( 'admin.php?page=sb2_log' ) ;
?>"><?php 
_e( 'The Log', 'seo-booster' );
?></a></li>
							</ul>
						</div>

					</div><!-- .wp-columns -->

				</div><!-- .welcome-panel-content -->
			</div><!--#inner-welcome-->
		</div><!-- .welcome-panel -->

		<?php 
$searchtrafficbyday_query = "SELECT daday, sum(visits) as totalvisits FROM {$wpdb->prefix}sb2_kwdt WHERE daday > DATE_SUB(NOW(), INTERVAL 120 DAY) GROUP BY daday ORDER BY daday ASC";
$searchtrafficbyday = $wpdb->get_results( $searchtrafficbyday_query );

if ( $searchtrafficbyday ) {
    ?>
			<div id="sb2traffic" class="clearfix clear">
				<h3><?php 
    _e( 'Visitors from Search Engines', 'seo-booster' );
    ?></h3>
				<div id="searchtrafficbydaychart"></div>
				<script type="text/javascript">
					google.charts.load('current', {packages: ['corechart']});
					google.charts.setOnLoadCallback(drawTrafficChart);
					function drawTrafficChart() {
						var data = google.visualization.arrayToDataTable([
							['Day','Visits'],
							<?php 
    foreach ( $searchtrafficbyday as $stbd ) {
        echo  "['" . $stbd->daday . "', " . $stbd->totalvisits . "]," ;
    }
    ?>
							]);

						var options = {
							title: '<?php 
    _e( 'Visitors from Search Engines', 'seo-booster' );
    ?>',
					curveType: 'function', // makes curved lines
					legend: { position: 'bottom' },
					backgroundColor : 'transparent',
					pointSize:7,
					titlePosition:'none',
					height:300,
					chartArea:{
						left:50,
						width:'100%'
					},
					series: [
					{
						color: '#36ace0',
						visibleInLegend: true
					}
					],
					lineWidth:4,
					trendlines: {
						0: {
							type: 'exponential',
							color: '#333',
							opacity: 1
						}
					}
				};
				var trafficchart = new google.visualization.LineChart(document.getElementById('searchtrafficbydaychart'));
				trafficchart.draw(data, options);
		} // function drawTrafficChart()

	</script>
</div><!-- #sb2traffic -->
<?php 
}

// if ($searchtrafficbyday)
?>

<div id="sb2dashboard" class="clearfix clear">
	<div>
		<?php 
$totalkeywords = $wpdb->get_var( "SELECT count(*) FROM {$wpdb->prefix}sb2_kw;" );
$totalunknown = $wpdb->get_var( "SELECT count(*) FROM {$wpdb->prefix}sb2_kw WHERE kw IN ('#','');" );
$totalknown = $wpdb->get_var( "SELECT count(*) FROM {$wpdb->prefix}sb2_kw WHERE kw NOT IN ('#','');" );
$totalvisits = $wpdb->get_var( "SELECT SUM(visits) FROM {$wpdb->prefix}sb2_kw;" );
$totalknownvisits = $wpdb->get_var( "SELECT SUM(visits) FROM {$wpdb->prefix}sb2_kw WHERE kw<>'#' AND kw<>'';" );
$totalunknownvisits = $wpdb->get_var( "SELECT SUM(visits) FROM {$wpdb->prefix}sb2_kw WHERE kw='#' OR kw='';" );
$topkeywords = $wpdb->get_results( "SELECT kw,lp,visits FROM {$wpdb->prefix}sb2_kw WHERE ig='0' AND kw<>'Internal Search' AND kw<>'#' AND kw<>'' GROUP BY kw ORDER BY visits DESC limit 10;", ARRAY_A );

if ( $topkeywords ) {
    ?>
			<h2><?php 
    _e( 'Top Keywords', 'seo-booster' );
    ?></h2>

			<table class="wp-list-table widefat">
				<thead>
					<tr>
						<th scope="col"><?php 
    _e( 'Keyword', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Landing Page', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Visits', 'seo-booster' );
    ?></th>
					</tr>
				</thead>
				<tbody>
					<?php 
    foreach ( $topkeywords as $topkw ) {
        echo  "<tr><td>" . $topkw['kw'] . "</td><td><a href='" . $topkw['lp'] . "'>" . $topkw['lp'] . "</a></td><td>" . number_format_i18n( $topkw['visits'] ) . "</td></tr>" ;
    }
    ?>
				</tbody>
				<tfoot>
					<tr>
						<th scope="col"><?php 
    _e( 'Keyword', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Landing Page', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Visits', 'seo-booster' );
    ?></th>
					</tr>
				</tfoot>
			</table>
			<?php 
}

$query = "SELECT engine, COUNT(*) as cnt, SUM(visits) as visits\n\t\tFROM {$wpdb->prefix}sb2_kw\n\t\tWHERE `ig`='0'\n\t\tAND engine<>'Internal Search'\n\t\tGROUP BY `engine`\n\t\tORDER BY `visits` DESC\n\t\tLIMIT 35;";
$engines = $wpdb->get_results( $query, ARRAY_A );

if ( $engines ) {
    ?>
			<h2><?php 
    _e( 'Top Search Engines', 'seo-booster' );
    ?></h2>
			<div id="searchengineschart"></div>
			<script type="text/javascript">
				google.charts.load('current', {'packages':['corechart','line']});

				google.charts.setOnLoadCallback(drawPieChart);

				function drawPieChart() {
					var data = google.visualization.arrayToDataTable([
						['<?php 
    _e( 'Day', 'seo-booster' );
    ?>', '<?php 
    _e( 'Visitors', 'seo-booster' );
    ?>'],
						<?php 
    foreach ( $engines as $eng ) {
        echo  "['" . $eng['engine'] . "', " . $eng['cnt'] . "]," ;
    }
    ?>
						]);
					var options = {
						backgroundColor : 'transparent',
						title: '<?php 
    _e( 'Top Search Engines', 'seo-booster' );
    ?>',
						height: 330,
						legend: {
							position: 'right',
							textStyle: {
								fontSize: 16
							}
						},
						pieHole: 0.2,
						chartArea: {
							'top': 10,
							'width':'100%',
							'left':0,
							'height': 310,
							'backgroundColor': {
								'fill': 'transparent',
								'opacity': 50
							},
							'width':'100%'
						}
					};
					var chart = new google.visualization.PieChart(document.getElementById('searchengineschart'));
					chart.draw(data, options);
				}
			</script>
			<?php 
}

?>
		<h2><?php 
_e( 'Backlink Stats', 'seo-booster' );
?></h2>
		<p><?php 
_e( 'Details of the backlinks recorded.', 'seo-booster' );
?></p>
		<?php 
$totalbls = $wpdb->get_var( "SELECT count(*) FROM {$bltable};" );
$totalblsignore = $wpdb->get_var( "SELECT count(*) FROM {$bltable} WHERE ig='1';" );
$totalblsverified = $wpdb->get_var( "SELECT count(*) FROM {$bltable} WHERE verified='1' AND ig<>'1';" );
$totalblsvisits = $wpdb->get_var( "SELECT SUM(visits) FROM {$bltable};" );
$totalblsignorevisits = $wpdb->get_var( "SELECT SUM(visits) FROM {$bltable} WHERE ig='1';" );
$totalblsverifiedvisits = $wpdb->get_var( "SELECT SUM(visits) FROM {$bltable} WHERE verified='1' AND ig<>'1';" );
?>
		<table class="wp-list-table widefat">
			<tr><td><?php 
_e( 'Verified', 'seo-booster' );
?></td><td><?php 
echo  number_format_i18n( $totalblsverified ) ;
?></td><td>(<?php 
echo  number_format_i18n( $totalblsverifiedvisits ) ;
?> <?php 
_e( 'Visits', 'seo-booster' );
?>)</td></tr>
			<tr><td><?php 
_e( 'Ignored', 'seo-booster' );
?></td><td><?php 
echo  number_format_i18n( $totalblsignore ) ;
?></td><td>(<?php 
echo  number_format_i18n( $totalblsignorevisits ) ;
?> <?php 
_e( 'Visits', 'seo-booster' );
?>)</td></tr>
			<tr><td><?php 
_e( 'Total', 'seo-booster' );
?></td><td><?php 
echo  number_format_i18n( $totalbls ) ;
?></td><td>(<?php 
echo  number_format_i18n( $totalblsvisits ) ;
?> <?php 
_e( 'Visits', 'seo-booster' );
?>)</td></tr>

		</table>
		<p><?php 
_e( 'Verified means SEO Booster has verified the link, and if possible collected anchor text and other details. Ignored links are backlinks that do not have a link back or are filtered for other reasons.', 'seo-booster' );
?></p>
		<?php 
$query = "SELECT domain,\n\t\t(SELECT COUNT(*) FROM {$bltable} O WHERE O.domain = M.domain ) AS totallinks,\n\t\t(SELECT SUM(D.visits) FROM {$bltable} D WHERE D.domain = M.domain ) AS totalvisits\n\t\tFROM {$bltable} M where ig='0' AND domain<>'' group by domain order by totalvisits desc limit 15;";
$samplelinks = $wpdb->get_results( $query, ARRAY_A );

if ( $samplelinks ) {
    ?>

			<h2><?php 
    _e( 'Top Linking Domains', 'seo-booster' );
    ?></h2>

			<table class="wp-list-table widefat">
				<thead>
					<tr>
						<th scope="col"><?php 
    _e( 'Domain', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Total Links', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Total Visits', 'seo-booster' );
    ?></th>
					</tr>
				</thead>
				<tbody>
					<?php 
    foreach ( $samplelinks as $sample ) {
        echo  "<tr><td>" . $sample['domain'] . "</td><td>" . $sample['totallinks'] . "</td><td>" . $sample['totalvisits'] . "</td></tr>" ;
    }
    ?>
				</tbody>
				<tfoot>
					<tr>
						<th scope="col"><?php 
    _e( 'Domain', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Total Links', 'seo-booster' );
    ?></th>
						<th scope="col"><?php 
    _e( 'Total Visits', 'seo-booster' );
    ?></th>
					</tr>
				</tfoot>

			</table>
			<?php 
}

?>
	</div>
</div>
</div> <!-- .wrap -->